# -*- coding: euc-jp -*-
"""goodic: goo ( http://dictionary.goo.ne.jp/ ) PythonǰΥ饤֥

goodic κǿ: http://matatabi.homeip.net/blog/setomits/categorylist_html?cat_id=35
goodic Υɥ: http://matatabi.homeip.net/doc/goodic.html"""


import urllib, sys, re

__version__ = '0.6.2'
__author__ = 'SETOGUCHI Mitsuhiro <http://matatabi.homeip.net/blog/setomits/>'

class Goodic:
    """Goodic 饹"""

##
    def __init__(self):
	"""֥Ȥν᥽å
ѤΥޥå result """
	self.result = {}

##
    def _set_params(self, kind, word, mode, proxy, base):
	params = {}

	if kind in ('je', 'ej', 'jn'):
	    params['kind'] = kind
	elif kind == 'jj':
	    params['kind'] = 'jn'
	else:
	    sys.exit('Please choose dictionary kind in "je", "ej", "jn", "jj"')

	if word:
	    params['MT'] = word
	else:
	    sys.exit('Please set word to consult')

	if mode in (0, 1, 2):
	    params['mode'] = mode
	else:
	    sys.exit('Please choose search mode in "0"(prefix), "1"(perfect), "2"(from explanation')

	if proxy:
	    proxy = {'http': proxy}
	    opener = urllib.FancyURLopener(proxy)
	else:
	    opener = urllib.URLopener()

	if type(base) is int and base > 0:
	    params['base'] = base
	else:
	    sys.exit('Please set "base" as integer greater than 0')

	url = "http://dictionary.goo.ne.jp/search.php?" + urllib.urlencode(params)

	return (url, opener)

##
    def _get_page(self, url, opener):
	try:
	    f = opener.open(url)
	except IOError:
	    sys.exit("Can't connect Goo.")

	page = f.read()
	f.close()

	return page

    def _get_headword_meaning_results(self, page):
	resultspat = re.compile('\[(\d*?)\]')
	hwpat = re.compile('<title>(.*?) - goo </title>')
	mnpat = re.compile('<div class="mainlst">(.*?)<font size="-2" font color="#666666">', re.DOTALL)
	rmpat = re.compile('<.*?>|&.*?;')

	searched = resultspat.search(page)
        if searched:
            results = int(searched.group(1))
        else:
            results = 0

	if results:
	    headword = hwpat.search(page).group(1)
	    headword = rmpat.sub('', headword).strip()
	    meaning = mnpat.search(page).group(1)
	    meaning = rmpat.sub('', meaning.replace('<br>', '\n')).strip()
	else:
	    headword = 'Not Found'
	    meaning = ''

	return (headword, meaning, results)

##
    def search(self, kind = '', word = '', mode = 0, proxy = '', base = 1):
	"""᥽å

 - kind: μꤹ
  - ±Ѽ: je
  - ¼: ej
  - 켭: jn or jj

 - word: оݤȤʤ

 - mode: λꤹ
  - סʥǥեȡ: 0
  - : 1
  - : 2
  - ʸ: 3

 - proxy: ץФѤϥץФ URL  ݡȤꤹ

 - base: ̤ΤĤη̤ߤꤹʥǥեȤ 1 


 ֤ͤ headword / meaning / results 򥭡Ȥޥåפǡ
 headword, meaning  Unicode"""

	word = word.encode('euc-jp', 'ignore')

	url, opener = self._set_params(kind, word, mode, proxy, base)
	page = self._get_page(url, opener)
	headword, meaning, results = self._get_headword_meaning_results(page)

	self.result['headword'] = unicode(headword, 'euc-jp', 'ignore')
	self.result['meaning'] = unicode(meaning, 'euc-jp', 'ignore')
	self.result['results'] = results

	return self.result

##
def search(kind = '', word = '', mode = 0, proxy = '', base = 1):
    """Goodic 饹 search() ᥽åɤåԥ󥰤ؿ"""
    gd = Goodic()

    return gd.search(kind, word, mode, proxy, base)

if __name__ == "__main__":
    gd = Goodic()

    d = gd.search("ej", "news")
    print d['headword'].encode('euc-jp')
    print d['meaning'].encode('euc-jp')
    print "There are", d['results'], "results."

    d = gd.search("ej", "news", 2)
    print d['headword'].encode('euc-jp')
    print d['meaning'].encode('euc-jp')
    print "There are", d['results'], "results."

    d = gd.search("je", unicode("ֱ", "euc-jp"))
    print d['headword'].encode('euc-jp')
    print d['meaning'].encode('euc-jp')
    print "There are", d['results'], "results."

    d = gd.search("jn", unicode("", "euc-jp"))
    print d['headword'].encode('euc-jp')
    print d['meaning'].encode('euc-jp')
    print "There are", d['results'], "results."
